  if {$tk_version >= 4.1} {
    source $patiencePath/htmllib.tcl
  }
  proc HMset_image {state win handle src} {
    global patiencePath sprache hilfsBilder currDir text

    helpStatus "$text(bildLesen) $src"
    if {![string match {[./]*} $src]} {
      set src $currDir/$src
    }
    set img [image create photo -file $src]
    HMgot_image $handle $img
    lappend hilfsBilder $img
  }
  proc HMlink_callback {state win href} {
    global currDir

    set href [HMmap_esc $href]
    switch -glob $href {
      tcl:* {
        set cmd [string range $href 4 end]
        regsub %X $cmd [winfo pointerx $win] cmd
        regsub %Y $cmd [winfo pointery $win] cmd
        eval $cmd
      }
      default {
        regsub {^[^:]*:} $href "" href
        set pathTag [split $href #]
        if {[llength $pathTag] > 1} {
          set href [lindex $pathTag 0]
          set tag  [lindex $pathTag 1]
        }
        if {[string length $href]} {
          if {![string match /* $href]} {
            set fName $currDir/$href
          } else {
            set fName $href
          }
          set currDir [file dirname $fName]

          if {[catch {open $fName r} file]} {
            helpStatus "File $fName not found."
          } else {
            $win configure -state normal
            HMreset_win $win
            loescheHilfsBilder
            zeigHtml $win $file $href
            $win configure -state disabled
            close $file
          }
        }
        if {[info exists tag]} {
          HMgoto $state $tag
        }
      }
    }
  }
  proc debug_puts {text} {}
  proc ersteHilfe {{helpName Patience}} {
    global sprache patiencePath text mitNetscape currDir

    set w .regeln

    if {![string match /* $helpName]} {
      set htmlFile $patiencePath/manual/$sprache/$helpName.html
    } else {
      set htmlFile $helpName.html
    }
    set currDir [file dirname $htmlFile]

    if {[catch {open $htmlFile} file]} {
      keineHilfe $htmlFile
      return
    }

    if {$mitNetscape \
        && ![catch "exec netscape -remote openFile($htmlFile)"]} {
      close $file
      return
    }

    if {[winfo exists $w]} {
      if {![string compare [wm state $w] iconic]} {wm deiconify $w}
      $w.text configure -state normal
      $w.text delete 1.0 end
      raise $w
    } else {
      toplevel    $w
      wm title    $w "$text(patience)$text(hilfe)"
      wm iconname $w "$text(patience)$text(hilfe)"

      button $w.quit -text $text(okay) -com "destroy $w; loescheHilfsBilder"
      pack   $w.quit   -side bottom -fill x

      label  $w.status -textvariable helpStatus
      pack   $w.status -side bottom -ipadx 10 -anchor w

      scrollbar $w.scroll -command "$w.text yview"
      pack      $w.scroll -side right -fill y

      text $w.text -yscrollcommand "$w.scroll set"
      pack $w.text -fill both -expand 1 -side left -ipady 10 -ipadx 10

      bind  $w.text <Prior>     "$w.text yview scroll -1 pages; break"
      bind  $w.text <Next>      "$w.text yview scroll  1 pages; break"
      bind  $w.text <Home>      "$w.text yview moveto  0;       break"
      bind  $w.text <End>       "$w.text yview moveto  1;       break"
      bind  $w.text <Control-c> "$w.quit invoke;                break"
      bind  $w.text <Enter>     "focus $w.text;                 break"
    }
    if {![string length [info commands HMinit_hyperwin]]} {
      helpStatus $text(nixHtml)
      while {[gets $file line] >= 0} {
        regsub -all {<[^>]*>} $line "" line
        $w.text insert end "$line\n"
      }
    } else {
      HMinit_hyperwin $w.text
      zeigHtml $w.text $file $htmlFile
    }
    catch {$w.text configure -state disabled}
    close $file
  }
  proc loescheHilfsBilder {} {
    global hilfsBilder

    if {[info exists hilfsBilder]} {
      foreach bild $hilfsBilder {
        image delete $bild
      }
      unset hilfsBilder
    }
  }
  proc helpStatus {txt} {
    global helpStatus
    set helpStatus $txt
    update
  }
  proc zeigHtml {w file fileName} {
    global renderCmds text

    helpStatus "$text(einlesen) $fileName..."
    set lastTag [HMparse_html [read $file] renderCmds 0 10 leftover HMrender]

    set i 0
    while {$i < $lastTag} {
      helpStatus "$text(anzeigen) ([expr {int(($i+1)*100/$lastTag)}]%)..."
      regsub -all {\\win\\} $renderCmds([incr i]) $w renderCmd
      if {[catch $renderCmd msg]} {
        switch -glob $msg {
          {bad option ""*}        {#ignore this}
          {invalid command name*} {return}
          default                 {debug_puts "$renderCmd: $msg"; return}
        }
      }
    }
    helpStatus "$text(anzeigen)...$text(fertig)"
    while {[regexp "^\[ \t\n]*$" [$w get end-2line end-1line]]} {
      $w delete end-2line end-1line
    }
  }
  proc keineHilfe {dateiName} {
    global text

    tk_dialog .t1 $text(keineHilfe) $text(da)$dateiName$text(fehlt) \
                  "" 0 $text(schade)
  }
